/////////////////////////////////////////////////////////////////
#define F_CPU 20000000L
#include <avr/io.h>
#include <Util/delay.h>
#include <avr/interrupt.h>
/////////////////////////////////////////////////////////////////
void timers_ini(void)
{
/////////////////////////////////////////////////////////////////////////

//========================================/ 0/=====================================
TCCR0A = 0;
TCCR0B = 0;
TCCR0A |= (1<<WGM01);                   //  CTC (  )
//TCCR0B |= (1<<CS00);                      //   CLK.
//    :
// TCCR0B = (1<<CS01);                   // CLK/8
// TCCR0B = (1<<CS00)|(1<<CS01); // CLK/64
// TCCR0B = (1<<CS02);                   // CLK/256
 TCCR0B = (1<<CS00)|(1<<CS02); // CLK/1024

//   .   0  255.
OCR0A = 255;                                   //   A  = Fclk/(N*(1+OCR0A))
OCR0B = 255;                                   //   B  = Fclk/(N*(1+OCR0B))
//  N - .  (1, 8, 64, 256  1024)
TIMSK0 |= (1<<OCIE0A);                  //     A
//TIMSK0 |= (1<<OCIE0B);                  //     B
//TIMSK0 |= (1<<TOIE0);                    //    
	
//========================================/ 1/=====================================
  TCCR1B = 0;
  TCCR1A = 0;
  TCCR1B |= (1<<WGM12);                    //  CTC (  )
  //TCCR1B |= (1<<CS10);                       //   CLK.
  //    :
  // TCCR1B |= (1<<CS11);                   // CLK/8
  // TCCR1B |= (1<<CS10)|(1<<CS11); // CLK/64
  // TCCR1B |= (1<<CS12);                   // CLK/256
   TCCR1B |= (1<<CS10)|(1<<CS12); // CLK/1024

  //   .   0  65535.
  OCR1A = 2678;                                   //   A  = Fclk/(N*(1+OCR1A))
  OCR1B = 2678;                                   //   A  = Fclk/(N*(1+OCR1B))
  //  N - .  (1, 8, 64, 256  1024)
  TIMSK1 |= (1<<OCIE1A);                    //     A
  //TIMSK1 |= (1<<OCIE1B);                    //     B
  //TIMSK1 |= (1<<TOIE1);                      //    	

////////////////////////////////////////////////////////////////////////////////////////////////////
}
ISR (TIMER0_COMPA_vect)	//      0
{
/////////////////////////////////////////////////////////////////	
if ((PINC&0b00000001))
 {
 PORTC &= ~(1<<0); //  PC0 
 }	
 else
  {
  PORTC |= (1<<0); //  PC0 		 		
  }
  
////////////////////////////////////////////////////////////////////  
}
ISR (TIMER1_COMPA_vect )
{
/////////////////////////////////////////////////////////////////////	
if ((PINC&0b00000001))
  {
  PORTC &= ~(1<<2); //  PC0 
  }
  else
   {
   PORTC |= (1<<2); //  PC0 
   }
///////////////////////////////////////////////////////////////////	
}
int main(void)
{
//===============================================================================	
	
	DDRC |= (1<<0); //  PC0  (     ) 
   PORTC &= ~(1<<0); //  PC0 
    DDRC &= ~(1<<1); 
   PORTC |= (1<<1);
    DDRC |= (1<<2); //  PC2  (     )
   PORTC &= ~(1<<2);//  PC2 
   
   timers_ini();
	sei();// 
	
	
//===============================================================================		
	while(1)
	{
		if (false == (PINB&0b00000010))
		{	
	
		//_delay_ms(500);			
		}
		
	}
//================================================================================	
}
